args <- commandArgs(trailingOnly = TRUE)
theta = as.numeric(args[1])
Fname = args[2]


CountTable3L = read.table("counts_table_for_DESeq")


Design3L = data.frame( row.names = colnames( CountTable3L ), condition = c( "untreated", "untreated", "untreated", "treated", "treated", "treated" ), libType = c( "single-end", "single-end", "single-end", "single-end", "single-end","single-end" ) )

singleSamples = Design3L$libType == "single-end"

countTable = CountTable3L[ , singleSamples]

condition = Design3L$condition[ singleSamples ]

library( "DESeq" )

full_cds = newCountDataSet( countTable, condition )

rs = rowSums ( counts ( full_cds ))

use = (rs > quantile(rs, probs=theta))

table(use)

cds = full_cds[use,]

cds = estimateSizeFactors( cds )

cds = estimateDispersions( cds )

res = nbinomTest( cds, "untreated", "treated" )

write.table(res, file = Fname, append = FALSE, quote = FALSE, sep = "\t", eol = "\n", na = "NA", dec = ".", row.names = TRUE, col.names = TRUE, qmethod = c("escape", "double"), fileEncoding = "")