#this is a shell script which outputs a genome wide count table of enhancer activity by 100bp bin (called "counts_table_for_DESeq" which is ready 
#to be sent to DESeq in R for differential activity analysis using a negative binomial test

#shell script is run without arguments but must contain the files listed below named as they are in quotes
#Necessary Files
#“N1_reads” : untreated1 experimental randomers
#“N2_reads” : untreated2 experimental randomers
#“N3_reads” : untreated3 experimental randomers
#“H1_reads” : treated1 experimental randomers
#“H2_reads” : treated2 experimental randomers
#“H3_reads” : treated3 experimental randomers
#“bad_matches” : outlying randomer-100bp bin matches
#“randomer_genomic_weighted_match_list”: match list linking randomers to the genomic regions whose activity they report




system("mkdir hundo");


@good_files = ();
@files = <*>;
$file_search = "reads";
foreach $file (@files) {
	if ($file =~ /$file_search/) {
		push (@good_files, $file);
	}
}
	
$length = $#good_files;
$i = 0;
while ($i<$lenght){

$analysis_file = @good_files[$i];

}

 $ch = 0;
        while ($ch < @good_files) {
                @pids = ();
                for ($c = 0; $c < 6; $c++) {
                        defined (my $pid = fork) or die "Cannot fork: $!\n";
                        if ($pid) {
                          push @pids, $pid;
                          next;
                        }
                        if (($c + $ch) < @good_files) {
				$file9 = $good_files[$c + $ch];
				print "hello\n";
				print "$file9\n";
                                               
				$file_hundoX = "hundo_X_"."$file9";

				$file_hundo2L = "hundo_2L_"."$file9";

				$file_hundo3L = "hundo_3L_"."$file9";

				$file_hundo2R = "hundo_2R_"."$file9";

				$file_hundo3R = "hundo_3R_"."$file9";

				system("perl data_hundo_allocator_from_weighted_list_hundo_stranded_corrected.pl randomer_genomic_weighted_match_list $file9 hundo/$file_hundoX hundo/$file_hundo2L hundo/$file_hundo2R hundo/$file_hundo3L hundo/$file_hundo3R bad_matches");
						                                
                        }        
                                        exit(0);
                        
                }
                for ($c = 0; $c < 6; $c++) {
                        waitpid $pids[$c], 0;
                }
                $ch = $ch + 6;
        }     



system("perl chromosome_displayer.pl hundo/hundo_X_N1_reads hundo/hundo_X_N2_reads hundo/hundo_X_N3_reads hundo/hundo_X_H1_reads hundo/hundo_X_H2_reads hundo/hundo_X_H3_reads hundo/all_six_hundo_X");

system("perl chromosome_displayer.pl hundo/hundo_2L_N1_reads hundo/hundo_2L_N2_reads hundo/hundo_2L_N3_reads hundo/hundo_2L_H1_reads hundo/hundo_2L_H2_reads hundo/hundo_2L_H3_reads hundo/all_six_hundo_2L");

system("perl chromosome_displayer.pl hundo/hundo_3L_N1_reads hundo/hundo_3L_N2_reads hundo/hundo_3L_N3_reads hundo/hundo_3L_H1_reads hundo/hundo_3L_H2_reads hundo/hundo_3L_H3_reads hundo/all_six_hundo_3L");

system("perl chromosome_displayer.pl hundo/hundo_2R_N1_reads hundo/hundo_2R_N2_reads hundo/hundo_2R_N3_reads hundo/hundo_2R_H1_reads hundo/hundo_2R_H2_reads hundo/hundo_2R_H3_reads hundo/all_six_hundo_2R");

system("perl chromosome_displayer.pl hundo/hundo_3R_N1_reads hundo/hundo_3R_N2_reads hundo/hundo_3R_N3_reads hundo/hundo_3R_H1_reads hundo/hundo_3R_H2_reads hundo/hundo_3R_H3_reads hundo/all_six_hundo_3R");

system("perl prepare_for_DESeq_chromosomes.pl hundo/all_six_hundo_2L hundo/all_six_hundo_2R hundo/all_six_hundo_3L hundo/all_six_hundo_3R hundo/all_six_hundo_X counts_table_for_DESeq");
