#takes in randomer_genomic_weighted_match_list and one replicate set of randomers and bins reads by hundred base pair 
#stretch across each chromosome, creating a file for each chromosome for each choromosome location, 
#assigns point to that hundred bp interval as well as the next four due to approx 450 bp size of fragment
#this version first verifies the randomer-genomic pair is not on the outlying list

if ($#ARGV == 7) {
	$fileIn_match = $ARGV[0];
	$fileIn_data = $ARGV[1];
	$file_outX = $ARGV[2];
	$file_out2L = $ARGV[3];
	$file_out2R = $ARGV[4];
	$file_out3L = $ARGV[5];
	$file_out3R = $ARGV[6];
	$file_bad = $ARGV[7];
	
} 


open(FILE_BAD, "<$file_bad")
	or die "Can't open input: $file $!";

while (<FILE_BAD>) { # read in an ID

	$Line= $_;
	chomp $Line;
	@TABs = split(/\t/, $Line);
	$loc = @TABs[0]."_".@TABs[1];
	$randomer = @TABs[2];
	$bad_matches{$loc} = $randomer;
}

close FILE_BAD;




open(MATCHLIST, "<$fileIn_match")
	or die "Can't open input: $file $!";



while (<MATCHLIST>) { # read in an ID

	$Line= $_;
	chop $Line;
	@TABs = split(/\t/, $Line);
	$randomer = @TABs[0];
	$j=1;
	$len = @TABs;
	while ($j<$len){
		$loc= $TABs[$j];
		$j++;
		$weight = $TABs[$j];
		$match_hash{$randomer}{$loc}=$weight;
		$j++;
		
	}
			
}

close MATCHLIST;

open(DATA, "<$fileIn_data")
	or die "Can't open output: $file_out $!";

while (<DATA>) { # read in an ID
	
	$Line= $_;
	chop $Line;
	$randomer = $Line;
	@deg_keys = &degen($randomer);
	foreach $d_key (@deg_keys) {
		if (exists $match_hash{$d_key} ) {
			for $loc ( keys %{ $match_hash{$d_key} } ) {
				if (substr($loc,0,3) eq "X_F"){
					$position = substr($loc,4);
					$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "X_".$kilo;
					$kiloP1 = $kilo+1;
					$kilo_locP1 = "X_".$kiloP1;
					$kiloP2 = $kilo+2;
					$kilo_locP2 = "X_".$kiloP2;
					$kiloP3 = $kilo+3;
					$kilo_locP3 = "X_".$kiloP3;
					$kiloP4 = $kilo+4;
					$kilo_locP4 = "X_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo] = $arrayX[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo+1] = $arrayX[$kilo+1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo+2] = $arrayX[$kilo+2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo+3] = $arrayX[$kilo+3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo+4] = $arrayX[$kilo+4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,3) eq "X_R"){
					$position = substr($loc,4);
					$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "X_".$kilo;
					$kiloP1 = $kilo-1;
					$kilo_locP1 = "X_".$kiloP1;
					$kiloP2 = $kilo-2;
					$kilo_locP2 = "X_".$kiloP2;
					$kiloP3 = $kilo-3;
					$kilo_locP3 = "X_".$kiloP3;
					$kiloP4 = $kilo-4;
					$kilo_locP4 = "X_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo] = $arrayX[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo-1] = $arrayX[$kilo-1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo-2] = $arrayX[$kilo-2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo-3] = $arrayX[$kilo-3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$arrayX[$kilo-4] = $arrayX[$kilo-4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,4) eq "2L_F"){
					$position = substr($loc,5);
					$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "2L_".$kilo;
					$kiloP1 = $kilo+1;
					$kilo_locP1 = "2L_".$kiloP1;
					$kiloP2 = $kilo+2;
					$kilo_locP2 = "2L_".$kiloP2;
					$kiloP3 = $kilo+3;
					$kilo_locP3 = "2L_".$kiloP3;
					$kiloP4 = $kilo+4;
					$kilo_locP4 = "2L_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo] = $array2L[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo+1] = $array2L[$kilo+1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo+2] = $array2L[$kilo+2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo+3] = $array2L[$kilo+3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo+4] = $array2L[$kilo+4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,4) eq "2L_R"){
					$position = substr($loc,5);
				$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "2L_".$kilo;
					$kiloP1 = $kilo-1;
					$kilo_locP1 = "2L_".$kiloP1;
					$kiloP2 = $kilo-2;
					$kilo_locP2 = "2L_".$kiloP2;
					$kiloP3 = $kilo-3;
					$kilo_locP3 = "2L_".$kiloP3;
					$kiloP4 = $kilo-4;
					$kilo_locP4 = "2L_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo] = $array2L[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo-1] = $array2L[$kilo-1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo-2] = $array2L[$kilo-2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo-3] = $array2L[$kilo-3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2L[$kilo-4] = $array2L[$kilo-4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,4) eq "2R_F"){
					$position = substr($loc,5);
					$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "2R_".$kilo;
					$kiloP1 = $kilo+1;
					$kilo_locP1 = "2R_".$kiloP1;
					$kiloP2 = $kilo+2;
					$kilo_locP2 = "2R_".$kiloP2;
					$kiloP3 = $kilo+3;
					$kilo_locP3 = "2R_".$kiloP3;
					$kiloP4 = $kilo+4;
					$kilo_locP4 = "2R_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo] = $array2R[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo+1] = $array2R[$kilo+1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo+2] = $array2R[$kilo+2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo+3] = $array2R[$kilo+3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo+4] = $array2R[$kilo+4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,4) eq "2R_R"){
					$position = substr($loc,5);
$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "2R_".$kilo;
					$kiloP1 = $kilo-1;
					$kilo_locP1 = "2R_".$kiloP1;
					$kiloP2 = $kilo-2;
					$kilo_locP2 = "2R_".$kiloP2;
					$kiloP3 = $kilo-3;
					$kilo_locP3 = "2R_".$kiloP3;
					$kiloP4 = $kilo-4;
					$kilo_locP4 = "2R_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo] = $array2R[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo-1] = $array2R[$kilo-1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo-2] = $array2R[$kilo-2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo-3] = $array2R[$kilo-3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array2R[$kilo-4] = $array2R[$kilo-4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,4) eq "3L_F"){
					$position = substr($loc,5);
				$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "3L_".$kilo;
					$kiloP1 = $kilo+1;
					$kilo_locP1 = "3L_".$kiloP1;
					$kiloP2 = $kilo+2;
					$kilo_locP2 = "3L_".$kiloP2;
					$kiloP3 = $kilo+3;
					$kilo_locP3 = "3L_".$kiloP3;
					$kiloP4 = $kilo+4;
					$kilo_locP4 = "3L_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo] = $array3L[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo+1] = $array3L[$kilo+1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo+2] = $array3L[$kilo+2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo+3] = $array3L[$kilo+3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo+4] = $array3L[$kilo+4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,4) eq "3L_R"){
					$position = substr($loc,5);
$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "3L_".$kilo;
					$kiloP1 = $kilo-1;
					$kilo_locP1 = "3L_".$kiloP1;
					$kiloP2 = $kilo-2;
					$kilo_locP2 = "3L_".$kiloP2;
					$kiloP3 = $kilo-3;
					$kilo_locP3 = "3L_".$kiloP3;
					$kiloP4 = $kilo-4;
					$kilo_locP4 = "3L_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo] = $array3L[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo-1] = $array3L[$kilo-1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo-2] = $array3L[$kilo-2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo-3] = $array3L[$kilo-3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3L[$kilo-4] = $array3L[$kilo-4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,4) eq "3R_F"){
					$position = substr($loc,5);
$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "3R_".$kilo;
					$kiloP1 = $kilo+1;
					$kilo_locP1 = "3R_".$kiloP1;
					$kiloP2 = $kilo+2;
					$kilo_locP2 = "3R_".$kiloP2;
					$kiloP3 = $kilo+3;
					$kilo_locP3 = "3R_".$kiloP3;
					$kiloP4 = $kilo+4;
					$kilo_locP4 = "3R_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo] = $array3R[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo+1] = $array3R[$kilo+1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo+2] = $array3R[$kilo+2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo+3] = $array3R[$kilo+3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo+4] = $array3R[$kilo+4] + $match_hash{$randomer}{$loc};

					}
				}
				if (substr($loc,0,4) eq "3R_R"){
					$position = substr($loc,5);
					$kilo = $position/100;
					$kilo = int($kilo);
					$kilo_loc = "3R_".$kilo;
					$kiloP1 = $kilo-1;
					$kilo_locP1 = "3R_".$kiloP1;
					$kiloP2 = $kilo-2;
					$kilo_locP2 = "3R_".$kiloP2;
					$kiloP3 = $kilo-3;
					$kilo_locP3 = "3R_".$kiloP3;
					$kiloP4 = $kilo-4;
					$kilo_locP4 = "3R_".$kiloP4;
					$check = 0;
					if($bad_matches{$kilo_loc} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo] = $array3R[$kilo] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP1} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo-1] = $array3R[$kilo-1] + $match_hash{$randomer}{$loc};
					}
					$check = 0;
					if($bad_matches{$kilo_locP2} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo-2] = $array3R[$kilo-2] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP3} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo-3] = $array3R[$kilo-3] + $match_hash{$randomer}{$loc};

					}
					$check = 0;
					if($bad_matches{$kilo_locP4} eq $randomer){
						$check = 1;
					}
					if ($check == 0){
						$array3R[$kilo-4] = $array3R[$kilo-4] + $match_hash{$randomer}{$loc};

					}
				}
			}			
			last;
		}
	}	

}

close DATA;



open(OUTPUTX, ">$file_outX")
	or die "Can't open input: $file $!";

$len = @arrayX;
$i=1;
while ($i<$len){
	print OUTPUTX "X\t$i\t@arrayX[$i]\n";
	$i++;
}

close OUTPUTX;


open(OUTPUT2L, ">$file_out2L")
	or die "Can't open input: $file $!";

$len = @array2L;
$i=1;
while ($i<$len){
	print OUTPUT2L "2L\t$i\t@array2L[$i]\n";
	$i++;
}

close OUTPUT2L;


open(OUTPUT2R, ">$file_out2R")
	or die "Can't open input: $file $!";

$len = @array2R;
$i=1;
while ($i<$len){
	print OUTPUT2R "2R\t$i\t@array2R[$i]\n";
	$i++;
}

close OUTPUT2R;


open(OUTPUT3L, ">$file_out3L")
	or die "Can't open input: $file $!";

$len = @array3L;
$i=1;
while ($i<$len){
	print OUTPUT3L "3L\t$i\t@array3L[$i]\n";
	$i++;
}

close OUTPUT3L;


open(OUTPUT3R, ">$file_out3R")
	or die "Can't open input: $file $!";

$len = @array3R;
$i=1;
while ($i<$len){
	print OUTPUT3R "3R\t$i\t@array3R[$i]\n";
	$i++;
}

close OUTPUT3R;



sub degen {
	my $dna = @_[0];
 	my $len = length($dna);
 	my $letter = "";
 	my @degs = ();
 	my @unique_degs = ();
 	my $deg = "";
 	my $left_side = "";
 	my $right_side = "";
 	my %seen =() ;

	for ($letter = 0; $letter < $len; $letter++) {
		#this does one bp degenerates
		$left_side = substr($dna,0,$letter);
		$right_side = substr($dna,$letter+1);
		$deg = $left_side . "A" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "T" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "C" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "G" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "N" . $right_side;
		push @degs, $deg;
		#this does one bp insertions i.e. left side goes through letter, right side end one before end
		$left_side = substr($dna,0,$letter);
		$right_side = substr($dna,$letter, $len-$letter-1);
		$deg = $left_side . "A" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "T" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "C" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "G" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "N" . $right_side;
		push @degs, $deg;
	}
	@unique_degs = grep { ! $seen{$_}++ } @degs ;	    

  return @unique_degs;
}
