# this script looks through a set of single-end fastq files in a folder which all contain a common name element (argument $base_name)
# for minimal promoter elements and the experimental barcode (argument $exp_bc) and quality filters them then prints the reverse complement
# of the randomer to a new file named as the argument $file_out.  a sample command line use is as follow
# "perl experimental_read_miner.pl lane_1 ATCCAT N1_reads"  

if ($#ARGV == 2) {
	$base_name = $ARGV[0];
	$exp_bc = $ARGV[1];
	$file_out = $ARGV[2];
} 



open(OUTPUT, ">$file_out");


$N = "N";
$search_seq_prev = "AGCCAACTTTGAATCACAAGACGCATACCAAAC";
$search_seq = $exp_bc.$search_seq_prev;

@good_files = ();
@files = <*>;
$file_search = "$base_name";
foreach $file (@files) {
	if ($file =~ /$file_search/) {

		open(FILE1B, "<$file");


		while (<FILE1B>) { # read in an ID

			$ID_line_1 = $_;
			$seq_line = <FILE1B>; #read in the sequence
			$ID_line_2 = <FILE1B>; # ID line
			$Quality_line = <FILE1B>; # quality read.  Can filter for poor reads here.
			$N_check = 0;
			$read_seq = substr($seq_line,0,39);
			$randomer_rc = substr($seq_line,39,20);
			if (index($randomer_rc, $N) != -1) {
   				$N_check = 1;
			}
			if($N_check == 0){
				if ($search_seq eq $read_seq)  {
					$randomer = reverse $randomer_rc;
					$randomer =~ tr/ACGT/TGCA/;
					print OUTPUT "$randomer\n";
				}
			}
		}
	}	
}
close OUTPUT;


