#This shell script finds enhancer construct match sequence pairs from paired-end fastq files(shell_concatenate.pl)
#, quality filters them (match_library_pe_QF.pl), and then creates a fasta file where the randomer tag is the name
#and the genomic sequence is the sequence (randomer_genomic_fasta_maker_from_fastq).  
#The final fasta file is then aligned to the Drosophila genome by the user using Bowtie2.

#ARGUMENTS
	
$name_R1 = $ARGV[0];		#0  $name_R1  (string) is the base name of read_1 files.  It is the common alphanumeric characters read1 file names begin with(up to the R1 so as not to include read2 as they are accessed in conjunction with the read 1 file).  This argument
								#is used to locate and open all relevant files using a single argument.
$Q_randomer = $ARGV[1];		#1  $Q_randomer (int) is the maximum acceptable probability in percent of a single error in the randomer stretch in read 2  
$Q_dmel = $ARGV[2];			#2  $Q_dmel (int) is the maximum acceptable probability in percent of a single error in the Drosophila melanogaster genomic fragment in read 1 
$len_dmel = $ARGV[3];		#3  $len_dmel (int) is the minimum length of read 1 genomic fragment


#OUTPUT FILES

$file_all_enhancer_seqs = "all_enhancer_pe_seqs.fastq";		#file to print shuffled paired-end construct match reads

$file_filtered_enhancer_seqs = "filtered_enhancer_pe_seqs.fastq";	#file of paired end sequences which have been quality filtered

$file_fa = "randomers_genomics.fa";						#output fasta file which is ready to be aligned to the Drosophila genome using bowtie2




system("perl shell_concatenate.pl $file_all_enhancer_seqs $name_R1");
system("perl match_library_pe_QF.pl $file_all_enhancer_seqs $file_filtered_enhancer_seqs $Q_randomer $Q_dmel $len_dmel");
system("perl randomer_genomic_fasta_maker_from_fastq.pl $file_filtered_enhancer_seqs $file_fa");