#This script takes an fastq input file of quality filtered match library fastq reads (output from match_library_pe_QF.pl) 
#and outputs a fasta file where the name is the randomer and the sequence is the drosophila genomic region


#ARGUMENTS
#0 	$file_in (string) is the quality_filtered paired-end fastq input file which is the output from match_library_pe_QF.pl 
#1  $file_out (string) is the output fasta file which is ready to be aligned to the Drosophila genome using bowtie2




if ($#ARGV == 1) {
	$file_in = $ARGV[0];
	$file_out = $ARGV[1];

}




open(OUTPUT, ">$file_out")
	or die "Can't open output: $file_out $!";


open(FILE, "<$file_in")
	or die "Can't open input: $file $!";



while (<FILE>) {

	$R1_ID1 = $_; chomp($R1_ID1);
	$R1_seq = <FILE>; chomp($R1_seq);
	$R1_ID2 = <FILE>; chomp($R1_ID2);
	$R1_qual = <FILE>; chomp($R1_qual);
	$R2_ID1 = <FILE>; chomp($R2_ID1);
	$R2_seq = <FILE>; chomp($R2_seq);
	$R2_ID2 = <FILE>; chomp($R2_ID2);
	$R2_qual = <FILE>; chomp($R2_qual);
	$genomic_seq = substr($R1_seq,0,50);
	$randomer = substr($R2_seq,0,20);
	print OUTPUT ">$randomer\n$genomic_seq\n";
}

close FILE;
close OUTPUT;
