#This script searches Illumina output fastq files from a paired-end run for those containing enhancer-construct sequences and
#then places them all in a single shuffled file.  Fastq outputs must be in the same folder the script is run from.

#ARGUMENTS
#0 	$file_out (string) name of file to print shuffled paired-end construct match reads
#1  $name_R1  (string) is the base name of read_1 files.  It is the common alphanumeric characters read1 file names begin with.  This argument
	#is used to locate and open all relevant files using a single argument.  

if ($#ARGV == 1) {
	$file_out = $ARGV[0];
	$name_R1 = $ARGV[1];
}



open(OUTPUT, ">$file_out");


$dmcp_15 = "GTTTGGTATGCGTCT";


@good_files2 = ();
@files2 = <*>;
$file_search2 = "$name_R1";
foreach $file (@files2) {
	if ($file =~ /$file_search2/) {

		@TABs = split(/R1/, $file);
		$file_pair = @TABs[0]."R2".@TABs[1];

		open(FILE1, "<$file") or die;
		open(FILE2, "<$file_pair") or die;

		while (<FILE1>) {

			$F1_ID1 = $_;
			$F1_seq = <FILE1>;
			$F1_ID2 = <FILE1>;
			$F1_qual = <FILE1>;
			$F2_ID1 = <FILE2>;
			$F2_seq = <FILE2>;
			$F2_ID2 = <FILE2>;
			$F2_qual = <FILE2>;

			$bc = substr($F2_seq,20,15);
			if ($bc eq $dmcp_15)  {

				print OUTPUT $F1_ID1;
				print OUTPUT $F1_seq;
				print OUTPUT $F1_ID2;
				print OUTPUT $F1_qual;
				print OUTPUT $F2_ID1;
				print OUTPUT $F2_seq;
				print OUTPUT $F2_ID2;
				print OUTPUT $F2_qual;
			}

		}

		close(FILE1);
		close(FILE2);
	}
}


close OUTPUT;
