#takes in $FileIn (unique and unaligned and highly repetitive concatenated file) and $FileIn_repeats (proper repeats) 
#and outputs final weighted randomer-genomic match list
if ($#ARGV == 2 && $ARGV[0] ne $ARGV[1]) {
	$fileIn = $ARGV[0];
	$fileIn_repeats = $ARGV[1];
	$file_out = $ARGV[2];
} 




open(OUTPUT, ">$file_out");


open(FILE, "<$fileIn");


while (<FILE>) { 
	
	$Line= $_;
	chop $Line;
	@TABs = split(/\t/, $Line);
	$randomer = @TABs[0];
	$locus = @TABs[1];

	if ($locus eq "highly_repetitive"){
		$genomic4 = "highly_repetitive";
		@genomics =($genomic4);
	}elsif($locus eq "unaligned"){
		$genomic4 = "unaligned";
		@genomics =($genomic4);
	}else{
		@locs = split(/_/, $locus);
		$chrom = @locs[0]."_".@locs[1];
		$num1 =  @locs[2]-3;
		$num2 =  @locs[2]-2;
		$num3 =  @locs[2]-1;
		$num4 =  @locs[2];
		$num5 =  @locs[2]+1;
		$num6 =  @locs[2]+2;
		$num7 =  @locs[2]+3;
		$genomic1 = $chrom ."_". $num1;
		$genomic2 = $chrom ."_". $num2;
		$genomic3 = $chrom ."_". $num3;
		$genomic4 = $chrom ."_". $num4;
		$genomic5 = $chrom ."_". $num5;
		$genomic6 = $chrom ."_". $num6;
		$genomic7 = $chrom ."_". $num7;
		@genomics = ($genomic1,$genomic2,$genomic3,$genomic4,$genomic5,$genomic6,$genomic7);
	}

	$randomer_tester=0;
	@deg_keys = &degen($randomer);
	foreach $d_key (@deg_keys) {
		if (exists $Randomer_hash{$d_key} ) {
			$randomer_tester=1;
			$randomer_match = $d_key;
			last;
		}
	}
	
	if ($randomer_tester == 0){
			
		$Randomer_hash{$randomer}{$genomic4}=1;
		
	}
	
	else{

		$genome_tester = 0;
	
		foreach $genomic (@genomics){
			if (exists $Randomer_hash{$randomer_match}{$genomic}){
				$genome_tester = 1;
				$Randomer_hash{$randomer_match}{$genomic} ++;
				last;
			}
		}
		if ($genome_tester ==0){
			$Randomer_hash{$randomer_match}{$genomic4}=1;
		}
	}


}

close FILE;

open(FILE_REPEATS, "<$fileIn_repeats");


while (<FILE_REPEATS>) { 
	
	$Line= $_;
	chop $Line;
	@TABs = split(/\t/, $Line);
	$randomer = @TABs[0];
	$locus = @TABs[1];
	@locs = split(/_/, $locus);
	$chrom = @locs[0]."_".@locs[1];
	$num1 =  @locs[2]-3;
	$num2 =  @locs[2]-2;
	$num3 =  @locs[2]-1;
	$num4 =  @locs[2];
	$num5 =  @locs[2]+1;
	$num6 =  @locs[2]+2;
	$num7 =  @locs[2]+3;
	$genomic1 = $chrom ."_". $num1;
	$genomic2 = $chrom ."_". $num2;
	$genomic3 = $chrom ."_". $num3;
	$genomic4 = $chrom ."_". $num4;
	$genomic5 = $chrom ."_". $num5;
	$genomic6 = $chrom ."_". $num6;
	$genomic7 = $chrom ."_". $num7;
	@genomics = ($genomic1,$genomic2,$genomic3,$genomic4,$genomic5,$genomic6,$genomic7);

	$randomer_tester=0;
	@deg_keys = &degen($randomer);
	foreach $d_key (@deg_keys) {
		if (exists $repeat_randomer_hash{$d_key} ) {
			$randomer_tester=1;
			$randomer_match = $d_key;
			last;
		}
	}
	
	if ($randomer_tester == 0){
			
		$repeat_randomer_hash{$randomer}{$genomic4}=$Line;
		
	}
	
	else{

		$genome_tester = 0;
	
		foreach $genomic (@genomics){
			if (exists $repeat_randomer_hash{$randomer_match}{$genomic}){
				$genome_tester = 1;
				last;
			}
		}
		if ($genome_tester ==0){
			$repeat_randomer_hash{$randomer_match}{$genomic4}=$Line;
		}
	}


	foreach $d_key (@deg_keys) {
		if (exists $Randomer_hash{$d_key} ) {
			$randomer_tester=1;
			$randomer_match = $d_key;
			last;
		}
	}
	
	if ($randomer_tester == 0){
			
		$Randomer_hash{$randomer}{$genomic4}=1;
		
	}
	
	else{

		$genome_tester = 0;
	
		foreach $genomic (@genomics){
			if (exists $Randomer_hash{$randomer_match}{$genomic}){
				$genome_tester = 1;
				$Randomer_hash{$randomer_match}{$genomic} ++;
				last;
			}
		}
		if ($genome_tester ==0){
			$Randomer_hash{$randomer_match}{$genomic4}=1;
		}
	}

}

close FILE_REPEATS;

for $randomer ( keys %Randomer_hash ) {

	$total = 0;
	print OUTPUT "$randomer";
	for $genomic ( keys %{ $Randomer_hash{$randomer} } ) {
		$total = $total + $Randomer_hash{$randomer}{$genomic};
	}
	for $genomic ( keys %{ $Randomer_hash{$randomer} } ) {
		$ratio = $Randomer_hash{$randomer}{$genomic}/$total;
		print OUTPUT "\t$genomic\t$ratio";
		if(exists $repeat_randomer_hash{$randomer} && exists $repeat_randomer_hash{$randomer}{$genomic}) {
			$repeats =  $repeat_randomer_hash{$randomer}{$genomic};
			@repeat_TABs = split(/\t/, $repeats);
			$len_repeats = @repeat_TABs;
			$j=2;
			while ($j<$len_repeats){
				print OUTPUT "\t@repeat_TABs[$j]\t$ratio";
				$j++;
			}
		}
	}
	print OUTPUT"\n";
}


close OUTPUT;



sub degen {
	my $dna = @_[0];
 	my $len = length($dna);
 	my $letter = "";
 	my @degs = ();
 	my @unique_degs = ();
 	my $deg = "";
 	my $left_side = "";
 	my $right_side = "";
 	my %seen =() ;

	for ($letter = 0; $letter < $len; $letter++) {
		#this does one bp degenerates
		$left_side = substr($dna,0,$letter);
		$right_side = substr($dna,$letter+1);
		$deg = $left_side . "A" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "T" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "C" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "G" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "N" . $right_side;
		push @degs, $deg;
		#this does one bp insertions i.e. left side goes through letter, right side end one before end
		$left_side = substr($dna,0,$letter);
		$right_side = substr($dna,$letter, $len-$letter-1);
		$deg = $left_side . "A" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "T" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "C" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "G" . $right_side;
		push @degs, $deg;
		$deg = $left_side . "N" . $right_side;
		push @degs, $deg;
	}
	@unique_degs = grep { ! $seen{$_}++ } @degs ;	    

  return @unique_degs;
}
